using System.Text.Json;
using Microsoft.AspNetCore.SignalR;
using Todo.Core.Interfaces.Persistence;

namespace Todo.Api.Hubs
{
    public class TodoHub : Hub
    {
        private readonly ITodoRepository _todoRepository;

        public TodoHub(ITodoRepository todoRepository)
        {
            _todoRepository = todoRepository;
        }

        public async Task GetInboxTodos()
        {
            await Clients.Caller.SendAsync("InboxTodos", "some data");
        }

        public async Task CreateTodo(string createTodoRequest)
        {
            var todo = JsonSerializer.Deserialize<Core.Entities.Todo>(createTodoRequest);
            if (todo is null)
                throw new InvalidOperationException("Failed to create todo because of invalid request");

            await _todoRepository.CreateTodoAsync(todo.Title);
        }
    }
}